import fetch from 'isomorphic-fetch';
import actionTypes from '../actiontype/refreshImg'
import {addErrorInfo} from './uploadError'
const domain = ENV.domain;

let json = {
    "meta": {
        "code": "200",
        "message": "成功",
        "success": true
    },
    "data": [
        {
            "id": 17,
            "filePath": "http://static.mjitech.com/static/sku/0/0/427/1471329704482.jpg"
        },
        {
            "id": 18,
            "filePath": "http://static.mjitech.com/static/sku/0/0/427/1471329704482.jpg"
        },
        {
            "id": 19,
            "filePath": "http://static.mjitech.com/static/sku/0/0/427/1471329704482.jpg"
        },
        {
            "id": 17,
            "filePath": "http://static.mjitech.com/static/sku/0/0/427/1471329704482.jpg"
        },
        {
            "id": 18,
            "filePath": "http://static.mjitech.com/static/sku/0/0/427/1471329704482.jpg"
        },
        {
            "id": 19,
            "filePath": "http://static.mjitech.com/static/sku/0/0/427/1471329704482.jpg"
        },
        {
            "id": 17,
            "filePath": "http://static.mjitech.com/static/sku/0/0/427/1471329704482.jpg"
        },
        {
            "id": 18,
            "filePath": "http://static.mjitech.com/static/sku/0/0/427/1471329704482.jpg"
        },
        {
            "id": 19,
            "filePath": "http://static.mjitech.com/static/sku/0/0/427/1471329704482.jpg"
        }
    ]
}

const refreshImg = (data)=>{
    return{
        type:actionTypes.REFRESHIMG,
        data
    }
};


const getRefreshImg = (errorId,type)=>{
    return(dispatch)=>{
        // fetch(domain + '/web/flush_image.action',{
        //     credentials : 'include',
        //     method : 'POST',
        //     mode : 'cors',
        //     body : {}
        //
        // }).then((response)=>response.json())
        //     .then(json=>{
        //         console.log(json);
        //     }).catch(e=>{console.error(e)})
        if(json.meta.success && json.data){
            let data = {
                errorId,
                type,
                files : json.data
            };
            dispatch(refreshImg(data))
        }

    }
};

const deleteImg = (errorId,type,fileId)=>{
    fetch(domain + '/web/delete_image_error.action',{
        credentials : 'include',
        method : 'POST',
        mode : 'cors',
        body : Object.assign({},{errorId,type,fileId})

    }).then((response)=>response.json())
        .then(json=>{
            if(json.meta.success){
                dispatch(getRefreshImg(errorId,type))
            }else {
                dispatch(addErrorInfo(json.meta.message))
            }
        }).catch(e=>{console.error(e)})
}

export {getRefreshImg,deleteImg}

