'use strict';
import React from 'react'
import { connect }  from 'react-redux';

import {getStoreInfo} from "../../actions/getStore";
import {getTroubleList} from "../../actions/getTroubles";
import {initGetOtherProblem,addNewProbem,deleteProblem,editProblemItem,submitProblemList} from "../../actions/otherQuestion"
import {scanBarCodeGetProductInfo,submitProductInfo} from "../../actions/ScanBarCode"
import {getReportDamageList,deleteDamageItem} from '../../actions/reportDamageList'
import {getRefreshImg,deleteImg} from "../../actions/refreshImg"
import {uploadError,addErrorInfo} from '../../actions/uploadError'
import {getUserinfo,logoutUser} from '../../actions/userinfo'
import PopupComponent from '../../components/CommonComponent/PopupComponent/PopupComponent'
import TroubleContainer from '../TroubleContainer/TroubleContainer'
import ScanBarCodeContainer from '../ScanBarCodeContainer/ScanBarCodeContaienr'
import ReportDamagesListContainer from '../ReportDamagesListContainer/ReportDamagesListContainer'
import OtherQuestionContainer from '../OtherQuestionContainer/OtherQuestionContainer'
import HomeContainer from '../HomeContainer/HomeContainer'
import FinishAskContainer from '../FinishAskContainer/FinishAskContainer'
import ChooseTaskContainer from '../ChooseTaskContainer/ChooseTaskContainer'
import Button from '../../components/CommonComponent/ButtonComponent/ButtonComponent';
import Clock from '../../components/CommonComponent/ClockComponent/ClockComponent';

import {on,remove} from '../../util/event';

require('./index.css');

const showPage = CONFIG.showPage;

const headerStatus = CONFIG.headerStatus;


const defaultPopupInfo = {
        showPopup : false, //是否显示弹窗
        popupChild : null, // 自定义弹窗内部htmls
        popupText : "", //默认弹窗的文本 （必填）
        popupButtons : [], // 默认弹窗的按钮
        classNames : '' //自定义类名
    };
const initPage = showPage[7];


class PageContainer extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            showPage : initPage,
            lastPage : '',
            page : null,
            popupInfo : defaultPopupInfo,
            pageStyle : {},
            lastPageStyle:{},
            showClock : false, //关门页面显示倒计时
            headerInfo : {}
        };
        this.getPages = this.getPages.bind(this); //获取当前页面
        this.showPopup = this.showPopup.bind(this); //显示弹窗
        this.hidePopup = this.hidePopup.bind(this); // 隐藏弹窗
        this.saveLastPage = this.saveLastPage.bind(this); //保存上一页
        this.goBack = this.goBack.bind(this); // 回到上一页
        this.handleTouch = this.handleTouch.bind(this); //监听页面触碰
        this.beginCountBack = this.beginCountBack.bind(this); //开始300s倒计时
        this.endCountBack = this.endCountBack.bind(this); //结束300s倒计时
        this.showAlarm = this.showAlarm.bind(this); //显示警告弹窗
        this.beginCloseDoor = this.beginCloseDoor.bind(this); //开始关门倒计时
        this.playAlarmMusic = this.playAlarmMusic.bind(this); //播放警报音乐
        this.overTimeSolve = this.overTimeSolve.bind(this); //超时未完成
        this.failCloseDoor = this.failCloseDoor.bind(this); //关门倒数未监听到关门成功
        this.judgeDoorStatus = this.judgeDoorStatus.bind(this); //关门倒数判断门是否关闭
        this.getSocketMsg = this.getSocketMsg.bind(this); //获得socket信息
        this.changePages = this.changePages.bind(this); //改变当前页
        this.emptyUser = this.emptyUser.bind(this); //清空当前用户信息，关门结束或者关门超时人工处理
        this.dealPageByType = this.dealPageByType.bind(this); //根据用户type判断显示页面
        this.showTroublePage = this.showTroublePage.bind(this); //根据用户type判断显示页面
        this.showError = this.showError.bind(this); //展示错误信息
        this.hideError = this.hideError.bind(this); //隐藏错误信息

        this.maxCountBackTime = 300;
        this.count = 1000;
        this.countbackTimer = null;
        this.countBackTime = -1;


        this.taskTypeOption = {
            'Trouble': this.showTroublePage
        };
    }

    connectOk(){
        console.log("connectOk")
    }

    componentWillMount() {
        let that = this;
        let {dispatch} = this.props;
        on(CONFIG.socketType.GETSTOREINFO,this,function (data) {
            console.log("==GETSTOREINFO===")
            console.log(data);
            dispatch(getStoreInfo(data.storeId));
        })
        on(CONFIG.socketType.GETSOCKETMSG,this,function (data) {
            console.log("==GETSTOREINFO===")
            console.log(data)
            console.log(this);
            that.getSocketMsg(data)
        })

    }


    emptyUser(){
        let {dispatch} = this.props;
        dispatch(logoutUser());
    }

    getSocketMsg(data){
        let {dispatch} = this.props;
        switch (data.type){
            case 'SUCCESS_OPENDOOR':
                //执行开门
                let info = JSON.parse(data.info);
                console.log("SUCCESS_OPENDOOR " ,info);
                dispatch(getUserinfo(info));
                break;
            case 'SUCCESS_CLOSEDOOR':
                //关门成功
                console.log("closedoor");
                dispatch(logoutUser());
                this.endCountBack();
                this.setState({
                    showPage : showPage[7],
                    showClock : false,
                    popupInfo : defaultPopupInfo
                });
                break;
        }
    }

    componentDidMount(){
        // this.beginCountBack()
        let {dispatch} = this.props;
    }
    componentDidUpdate() {
    }
    componentWillReceiveProps(nextProps){
        let {state,dispatch} = nextProps;
        let userinfo = state.userInfo;
        let nowUserInfo = this.props.state.userInfo;
        let isNotOneUser = userinfo.employee && userinfo.employee.id &&
            (!nowUserInfo || !nowUserInfo.employee || (nowUserInfo.employee.id !== userinfo.employee.id));
        let isNotOneTask = userinfo.types && userinfo.types !== nowUserInfo.types;

        console.log(isNotOneTask);
        console.log(isNotOneUser)

        if(isNotOneUser && isNotOneTask){
            this.dealPageByType(userinfo.types);
        }
        console.log(state.errMsg);
        if(state.errMsg.errMsg){
            this.showError(state.errMsg.errMsg)
        }
    }
    componentWillUnmount(){
    }

    showError(errMsg){
        let btnDom = <Button key={"pagecountBack1"} style={{'width':'260px'}} text={'确定'} option={this.hideError}/>
        this.showPopup({
            popupText : errMsg,
            popupButtons:[btnDom]
        })
    }

    hideError(){
        console.log("hideError");
        let {dispatch} = this.props;
        dispatch(addErrorInfo(""));
        this.hidePopup();
    }


    dealPageByType(type){
        let {dispatch,state} = this.props;
        if(this.taskTypeOption[type] && state.headerInfo){
            this.taskTypeOption[type](state.headerInfo);
        }
    }

    showTroublePage(info){
        let {dispatch} = this.props;
        dispatch(getTroubleList(info))
        this.setState({
            showPage : showPage[1]
        },()=>{
            this.beginCountBack();
        });
    }




    changePages(page){
        this.setState({
            showPage : page,
            popupInfo : defaultPopupInfo
        })
    }

    //开始倒计时,看有没有操作，只是在整个开门过程中才监听

    beginCountBack(){
        this.countBackTime = this.maxCountBackTime;
        clearTimeout(this.countbackTimer);
        this.countbackTimer = null;
        this.countBack.bind(this)();
    }

    endCountBack(){
        console.log("endCountBack")
        this.countBackTime = -1;
        clearTimeout(this.countbackTimer);
        this.countbackTimer = null;
    }

    overTimeSolve(){
        //300s 无人操作，点击确定
        this.setState({
            popupInfo : defaultPopupInfo
        },()=>{
            this.beginCountBack()
        })
    }

    countBack(){
        console.log("countbackTimer ",this.countbackTimer,)
        if(!this.countbackTimer && this.countBackTime >= 0){
            this.countBackTime--;
            console.log(this.countBackTime)
            this.countbackTimer = window.setTimeout(()=>{
                if(this.countBackTime > 0){
                    clearTimeout(this.countbackTimer);
                    this.countbackTimer = null;
                    this.countBack();
                }else{
                    //超过300s未点击，进入异常状态
                    clearTimeout(this.countbackTimer);
                    this.countbackTimer = null;
                    let btnDom = <Button key={"pagecountBack1"} style={{'width':'260px'}} text={"确定"} option={this.overTimeSolve}/>
                    let clockDom = <Clock key={"pagecountBack2"} totalTime={60}
                                          style={{'width':'260px','marginLeft':'30px','borderRadius':'10px'}}
                                          callback={this.showAlarm}
                    />
                    this.showPopup({
                        popupText : '您是否还在店铺准备执行您的任务',
                        popupButtons:[btnDom,clockDom]
                    })
                }
            },this.count);
        }

    }
    //弹出警告弹窗，并报警
    showAlarm(){
        console.log("showAlarm");
        let btnDom = <Button key={"pagecountBack1"} style={{'width':'260px'}} text={"确定"} option={this.beginCloseDoor}/>
        let clockDom = <Clock key={"pagecountBack2"} totalTime={30}
                              style={{'width':'260px','marginLeft':'30px','borderRadius':'10px'}}
                              callback={this.beginCloseDoor}
        />;
        this.setState({
            popupInfo : defaultPopupInfo
        },()=>{
            this.showPopup({
                popupText : '检测到店铺反常，请站出店铺，关闭店铺门后重新验证您的身份',
                popupButtons:[btnDom,clockDom]
            });
            this.playAlarmMusic()
        })

    }

    //关门
    beginCloseDoor(){
        console.log("beginCloseDoor");
        this.setState({
            popupInfo:defaultPopupInfo
        },()=>{
            let clockDom = <Clock key={"pagecountBack2"} totalTime={30}
                                  style={{'width':'260px','marginLeft':'30px','borderRadius':'10px'}}
                                  text={"关门中"}
                                  callback={this.judgeDoorStatus}
            />;
            this.showPopup({
                popupText : '关门倒数，请尽快站到设备外关闭设备门',
                popupButtons:[clockDom]
            })
        })

    }

    closeDoor(){

    }

    failCloseDoor(){
        this.playAlarmMusic();
        let {dispatch} = this.props;
        dispatch(uploadError());
    }

    judgeDoorStatus(){
        //成功关门
        //关门失败
        this.failCloseDoor()
    }

    playAlarmMusic(){
        //播放警报音乐
        console.log("playMusic");
    }

    hidePopup(){
        if(this.state.popupInfo.showPopup){
            this.setState({
                popupInfo : defaultPopupInfo
            })
        }

    }
    showPopup(info){
        //eg : info = {popupText:'test',popupButtons:[{text : '返回',option:FUNCTION}]}
        let popupInfo = Object.assign({},defaultPopupInfo,info);
        if(
            (   popupInfo.popupChild ||
                popupInfo.popupText ||
                (popupInfo.popupButtons && popupInfo.popupButtons.length > 0)
            ) && !popupInfo.showPopup
        ){
            popupInfo.showPopup = true; //以防未设置显示弹窗，做此判断。
        }

        this.setState({
            popupInfo : popupInfo,
        })
    }

    saveLastPage(page,pageStyle){
        this.setState({
            lastPage : page,
            lastPageStyle : pageStyle
        })
    }


    goBack(){
        console.log("goback")
        let lastPage = this.state.lastPage;
        let pageStyle = this.state.lastPageStyle;
        this.setState({
            showPage: lastPage,
            pageStyle : pageStyle

        })
    }

    getPages(){
        let pages = null;
        let{state,dispatch} = this.props;
        switch (this.state.showPage){
            case showPage[1]:
                pages = <TroubleContainer
                    troubleList={state.troubleList}
                    refreshImg = {state.refreshImg}
                    storeInfo={state.storeInfo}
                    userInfo={state.userInfo}
                    initTroubleList={()=>dispatch(getTroubleList())}
                    showTextArea={(text)=>this.showTextArea(text)}
                    showPopup={(info)=>this.showPopup(info)}
                    hidePopup={()=>this.hidePopup()}
                    changePages={()=>this.changePages()}
                    getRefreshImg={(errorId,type)=>dispatch(getRefreshImg(errorId,type))}
                    deleteImg={(errorId,type,fileId)=>dispatch(deleteImg(errorId,type,fileId))}
                />;
                break;
            case showPage[2]:
                pages = <ScanBarCodeContainer
                            getProductInfo = {(postData)=>dispatch(scanBarCodeGetProductInfo(postData))}
                            submitProductInfo = {(postData)=>dispatch(submitProductInfo(postData))}
                            state = {state}
                />;
                break;
            case showPage[3]:
                pages = <ReportDamagesListContainer
                            getReportDamageList = {(postData)=>dispatch(getReportDamageList(postData))}
                            deleteDamageItem = {(postData)=>{dispatch(deleteDamageItem(postData))}}
                            state = {state}
                />;
                break;
            case showPage[4]:
                pages = <OtherQuestionContainer
                            initStart = {(postData)=>dispatch(initGetOtherProblem(postData))}
                            addNewProblem = {(postData)=>dispatch(addNewProbem(postData))}
                            editProblemItem = {(data)=>dispatch(editProblemItem(data))}
                            deleteProblem = {(data)=>dispatch(deleteProblem(data))}
                            submitProblemList = {(data)=>dispatch(submitProblemList(data))}
                            state = {state}
                        />;
                break;
            case showPage[7]:
                pages = <HomeContainer showClock={this.state.showClock} storeInfo={state.storeInfo}
                                       userInfo={state.userInfo}/>;
                break;
            case showPage[8]:
                pages = <FinishAskContainer />;
                break;
            case showPage[9]:
                pages = <ChooseTaskContainer storeInfo={state.storeInfo}
                                             userInfo={state.userInfo}/>;
                break;
        }
        return pages;
    }

    handleTouch(){
        console.log("handleTouch");
        this.countBackTime = this.maxCountBackTime;
    }

    render() {
        let {state} = this.props;
        return (
            <div className={"pageContainer "} style={this.state.pageStyle} onTouchStart={()=>this.handleTouch()}>
                <PopupComponent popupInfo={this.state.popupInfo} />
                {this.getPages()}
            </div>
        )
    }
}

function select(store) {
    return Object.assign({}, {state: store})
}

export default connect(select)(PageContainer)